/*!
  spica javascript libraries - benchmark.js
  == written by Takuya Otani <takuya.otani@gmail.com> ===
  == Copyright (C) 2006 SimpleBoxes/SerendipityNZ Ltd. ==
*/

// [guideline]
// -- http://serennz.sakura.ne.jp/guidelines/js_en_000.txt
// -- http://serennz.sakura.ne.jp/guidelines/js_ja_000.txt

// ver 0.01 [2009/01/28] added toString in Benchmark
// ver 0.00 [2008/11/01] the first attempt

// === debug ===
Spica.debugOutput = function(object,reset)
{
	var dbg = document.getElementById("debug");
	if (!dbg) return;
	if (reset) dbg.innerHTML = '';
	dbg.innerHTML += '<strong>' + object + '</strong><br />';
	if (typeof(object) != 'string')
		for (key in object) dbg.innerHTML += key + ' : ' + object[key] + '<br />';
	dbg.style.fontFamily = 'mono-space';
}
Spica.stackTrace = function(arg)
{
	var stack = new Array();
	if (!arg.callee || !arg.callee.caller) return;
	for (var func = arg.callee; func != null; func = func.caller)
	{
		func.toString().match(/function (\w*)(\(.*\))/);
		var str = (RegExp.$1.length == 0) ? 'anonymouse' : RegExp.$1;
		str = str + RegExp.$2;
		if (arguments.callee.caller == func) str += '* ' + str;
		stack.push(str);
	}
	return stack;
}
// === benchmark ===
Spica.Benchmark = function()
{
	this.buffer = (new Date()).getTime();
	return this;
}
Spica.Benchmark.prototype = {
	check : function()
	{
		return (new Date()).getTime() - this.buffer;
	},
	toString : function()
	{
		var time = this.check();
		if ( time < 1000 ) return time + 'ms';
		var hour = parseInt( time / ( 1000 * 60 * 60 ) );
		var min  = ( parseInt( time / ( 1000 * 60 ) ) % 60 );
		var sec  = ( parseInt( time / 100 ) % 600 ) / 10;
		if ( hour > 0 && min < 9 ) min = '0' + min;
		if ( ( hour > 0 || min  > 0 ) && sec < 9 ) sec = '0' + sec;
		if ( hour > 0 ) return hour + "'" + min + '"' + sec;
		if ( min  > 0 ) return min  + '"' + sec;
		return sec + 's';
	}
};
